ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.3 by root, Wed Mar 7 18:04:44 2007 UTC vs.
Revision 1.85 by root, Fri May 14 22:56:47 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 59
25sub usage { 60sub usage {
26 warn <<EOF; 61 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 63 [--install-arch path]
39my $VERBOSE = 1; 74my $VERBOSE = 1;
40my $CACHE = 0; 75my $CACHE = 0;
41my $FORCE; 76my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
44 96
45END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
46 98
47Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
49 123
50mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
51 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
52 126
53sub fork_sub(&) { 127sub fork_sub(&) {
66} 140}
67 141
68sub inst_maps($) { 142sub inst_maps($) {
69 my (undef, $path) = @_; 143 my (undef, $path) = @_;
70 144
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 146
73 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
76 } 150 }
77 151
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
79} 159}
80 160
81{ 161{
82 our @PNG; 162 our %ANIMINFO;
163 our %FACEINFO;
164 our %RESOURCE;
83 our @ARC; 165 our @ARC;
166 our %ARC;
167 our $TRS;
84 our $NFILE; 168 our $NFILE;
169 our $PATH;
85 170
86 our (@png, @trs, @arc); # files we are interested in 171 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
87 172
173 our $c_arc = new Coro::Channel;
174 our $c_trs = new Coro::Channel;
175 our $c_res = new Coro::Channel;
176
177 our @c_png;
178
88 sub commit_png { 179 sub commit_png($$$) {
89 my ($name, $data) = @_; 180 my ($name, $data, $T) = @_;
90 #warn "$name: commited\n"; 181
182 $FACEINFO{$name}{"data$T"} = $data;
91 } 183 }
92 184
93 sub process_png { 185 sub process_png {
94 while (@png) { 186 while (@c_png) {
95 my $path = pop @png; 187 my ($path, $delete) = @{pop @c_png};
96 188
97 my $png; 189 my $png;
98 aio_lstat $path; 190 aio_lstat $path;
99 my ($size, $mtime) = (stat _)[7,9]; 191 my ($size, $mtime) = (stat _)[7,9];
100 192
101 if (0 > aio_load $path, $png) { 193 if (0 > aio_load $path, $png) {
102 warn "$path: $!, skipping.\n"; 194 warn "$path: $!, skipping.\n";
103 return; 195 next;
104 } 196 }
105 197
198 my $stem = $path;
199 my $T;
200
201 if ($stem =~ s/\.32x32\.png~?$//) {
202 $T = 32;
203 } elsif ($stem =~ s/\.64x64\.png~?$//) {
204 $T = 64;
205 } else {
206 warn "$path: weird filename, skipping.\n";
207 next;
208 }
209
106 # quickly extratc width and height of the (necessarily PNG) image 210 # quickly extract width and height of the (necessarily PNG) image
107 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 211 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
108 warn "$path: not a recongized png file, skipping.\n"; 212 warn "$path: not a recognized png file, skipping.\n";
109 return; 213 next;
110 } 214 }
111 215
112 my ($w, $h) = unpack "NN", $1; 216 my ($w, $h) = unpack "NN", $1;
113
114 (my $face = $path) =~ s/^.*\///;
115 my $T = 32;
116
117 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
118 warn "$path: weird filename, skipping.\n";
119 return;
120 }
121 217
122 if ($w < $T || $h < $T) { 218 if ($w < $T || $h < $T) {
123 warn "$path: too small ($w $h), skipping.\n"; 219 warn "$path: too small ($w $h), skipping.\n";
124 return; 220 next;
125 } 221 }
126 222
127 if ($w % $T || $h % $T) { 223 if ($w % $T || $h % $T) {
128 warn "$path: weird png size ($w $h), skipping.\n"; 224 warn "$path: weird png size ($w $h), skipping.\n";
129 return; 225 next;
226 }
227
228 (my $base = $stem) =~ s/^.*\///;
229
230 my $fi = $FACEINFO{$base};
231 unless ($fi) {
232 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
233 #next;
234 }
235
236 my $arc = $fi->{arc} || { };
237
238 unless ($path =~ /~$/) {
239 # possibly enlarge
240 if (0 > aio_stat "$stem.64x64.png") {
241 my $other = "$stem.64x64.png~";
242
243 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
244 fork_sub {
245 my $CROP;
246 my $SRC = "png:\Q$path\E";
247
248 my $is_floor = $arc->{is_floor};
249 my $is_wall = 0;
250
251 my ($wall_pfx, $wall_dir, $wall_sfx);
252
253 if (
254 !$is_floor
255 && !$arc->{alive}
256 && $arc->{move_block} eq "all"
257 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
258 ) {
259 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
260
261 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
262 $is_wall = 1;
263 }
264 }
265
266 if ($is_wall || $is_floor) {
267 # add a 4px border and add other images around it
268 $CROP = "-shave 8x8 +repage";
269
270 $w += 8;
271 $h += 8;
272
273 $SRC = "-size ${w}x${h} xc:transparent";
274 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
275
276 # 8 surrounding images
277 for (
278 # x y b r0 r1
279 [-1, -1, 0, 6],
280 [ 0, -1, 1, 10, 14],
281 [+1, -1, 0, 12],
282
283 [-1, 0, 8, 5, 7],
284 #
285 [+1, 0, 2, 5, 13],
286
287 [-1, +1, 0, 3],
288 [ 0, +1, 4, 10, 11],
289 [+1, +1, 0, 9],
290 ) {
291 my ($x, $y, $d, $r0, $r1) = @$_;
292
293 my $tile = $is_floor ? $path
294 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
295 : die;
296
297 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
298 "\Q$tile",
299 $x * ($w - 8) + 4,
300 $y * ($h - 8) + 4;
301 }
302 }
303
304 system "convert -depth 8 $SRC rgba:-"
305 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
306 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
307 and die "convert/cfhq2xa pipeline error: status $? ($!)";
308 system $OPTIPNG, "-i0", "-q", "$other~";
309 die "$other~ has zero size, aborting." unless -s "$other~";
310 rename "$other~", $other;
311 };
312 }
313
314 push @c_png, [$other, !$CACHE];
130 } 315 }
131 316
317 # possibly scale down
318 if (0 > aio_stat "$stem.32x32.png") {
319 my $other = "$stem.32x32.png~";
320
321 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
322 fork_sub {
323 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
324 system $OPTIPNG, "-i0", "-q", "$other~";
325
326 # reduce smoothfaces >10000 bytes
327 # obsolete, no longer required
328 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
329 my $ncolor = 256;
330 while () {
331 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
332 system $OPTIPNG, "-i0", "-q", "$other~~";
333 last if 10000 > -s "$other~~";
334 $ncolor = int $ncolor * 0.9;
335 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
336 }
337
338 printf "reduced %s from %d to %d bytes using %d colours.\n",
339 $other, -s "$other~", -s "$other~~", $ncolor
340 if $VERBOSE >= 2;
341 rename "$other~~", "$other~";
342 }
343
344 die "$other~ has zero size, aborting." unless -s "$other~";
345 rename "$other~", $other;
346 };
347 }
348
349 #warn "scaled down $path to $other\n";#d#
350 push @c_png, [$other, !$CACHE];
351 }
352 }
353
354 (my $face = $stem) =~ s/^.*\///;
355
356 # split all bigfaces, but avoid smoothfaces (*_S)
132 if (($w > $T || $h > $T) && $face !~ /_S\./) { 357 if (($w > $T || $h > $T) && $face !~ /_S\./) {
133 # split 358 # split
134 my @tile; 359 my @tile;
135 for my $x (0 .. (int $w / $T) - 1) { 360 for my $x (0 .. (int $w / $T) - 1) {
136 for my $y (0 .. (int $h / $T) - 1) { 361 for my $y (0 .. (int $h / $T) - 1) {
149 (map { 374 (map {
150 ( 375 (
151 "(", 376 "(",
152 "+clone", 377 "+clone",
153 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 378 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
379 "+repage",
380 -quality => "00",
154 -write => "png:$_->[2]~", 381 -write => "png32:$_->[2]~",
155 "+delete", 382 "+delete",
156 ")", 383 ")",
157 ) 384 )
158 } @todo), 385 } @todo),
159 "null:"; 386 "null:";
163 close $convert; 390 close $convert;
164 391
165 # pass 2, optimise, and rename 392 # pass 2, optimise, and rename
166 for (@todo) { 393 for (@todo) {
167 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 394 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
395 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
168 rename "$_->[2]~", $_->[2]; 396 rename "$_->[2]~", $_->[2];
169 } 397 }
170 }; 398 };
171 } 399 }
172 400
176 404
177 if (0 > aio_load $file, $tile) { 405 if (0 > aio_load $file, $tile) {
178 die "$path: unable to read tile +$x+$y, aborting.\n"; 406 die "$path: unable to read tile +$x+$y, aborting.\n";
179 } 407 }
180 IO::AIO::aio_unlink $file unless $CACHE; 408 IO::AIO::aio_unlink $file unless $CACHE;
181 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 409 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
182 } 410 }
183 } else { 411 } else {
184 # use as-is (either small, use smooth) 412 # use as-is (either small, use smooth)
185 commit_png $face, $png; 413 commit_png $face, $png, $T;
186 } 414 }
415
416 aio_unlink $path if $delete;
187 } 417 }
188 } 418 }
189 419
190 sub process_arc { 420 sub process_arc {
191 while (@arc) { 421 while (my $job = $c_arc->get) {
192 my ($dir, $file) = @{pop @arc}; 422 my ($dir, $file) = @$job;
193 423
194 my $arc; 424 my $arc;
195 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 425 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
426
196 my $arc = read_arch "$dir/$file"; 427 my $arc = read_arch "$dir/$file";
428 for my $o (values %$arc) {
429 push @ARC, $o;
430 for (my $m = $o; $m; $m = $m->{more}) {
431 $ARC{$m->{_name}} = $m;
432 }
433
434 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
435
436 my $visibility = delete $o->{visibility};
437 my $magicmap = delete $o->{magicmap};
438
439 # find upper left corner :/
440 # omg, this is sooo broken
441 my ($dx, $dy);
442 for (my $o = $o; $o; $o = $o->{more}) {
443 $dx = $o->{x} if $o->{x} < $dx;
444 $dy = $o->{y} if $o->{y} < $dy;
445 }
446
447 for (my $o = $o; $o; $o = $o->{more}) {
448 my $x = $o->{x} - $dx;
449 my $y = $o->{y} - $dy;
450
451 my $ext = $x|$y ? "+$x+$y" : "";
452
453 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
454
455 $visibility = delete $o->{visibility} if exists $o->{visibility};
456 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
457
458 my $anim = delete $o->{anim};
459
460 if ($anim) {
461 # possibly add $ext to the animation name to avoid
462 # the need to specify archnames for all parts
463 # of a multipart archetype.
464 $o->{animation} = "$o->{_name}";
465 my $facings = 1;
466 my @frames;
467
468 for (@$anim) {
469 if (/^facings\s+(\d+)/) {
470 $facings = $1*1;
471 } elsif (/^blank.x11$|^empty.x11$/) {
472 push @frames, $_;
473 } else {
474 push @frames, "$_$ext";
475 }
476 }
477
478 $ANIMINFO{$o->{animation}} = {
479 facings => $facings,
480 frames => \@frames,
481 };
482 }
483
484 for ($o->{face} || (), @{$anim || []}) {
485 next if /^facings\s/;
486
487 my $face = $_;
488 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
489
490 my $info = $FACEINFO{$face} ||= { };
491 $info->{arc} = $o;
492
493 next if $face =~ /^blank.x11$|^empty.x11$/;
494
495 $info->{visibility} = $visibility if defined $visibility;
496 $info->{magicmap} = $magicmap if defined $magicmap;
497 }
498
499 if (my $smooth = delete $o->{smoothface}) {
500 my %kv = split /\s+/, $smooth;
501 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
502 while (my ($face, $smooth) = each %kv) {
503 $FACEINFO{$smooth}{arc} = $o;
504
505 $FACEINFO{$face}{smooth} = $smooth;
506 $FACEINFO{$face}{smoothlevel} = $level;
507 }
508 }
509 }
510 }
197 } 511 }
198 } 512 }
199 513
200 sub process_trs { 514 sub process_trs {
201 while (@trs) { 515 while (my $job = $c_trs->get) {
202 my ($dir, $file) = @{pop @trs}; 516 my ($dir, $file) = @$job;
517 my $path = "$dir/$file";
518
519 my $trs;
520 if (0 > aio_load $path, $trs) {
521 warn "$path: $!, skipping.\n";
522 next;
523 }
524
525 $TRS .= $trs;
526 }
527 }
528
529 my %FILECACHE;
530
531 sub load_cached($;$) {
532 unless (exists $FILECACHE{$_[0]}) {
533 my $data;
534 if (0 < aio_load $_[0], $data) {
535 if ($_[1]) {
536 $data = eval { $_[1]->($data) };
537 warn "$_[0]: $@" if $@;
538 }
539 }
540
541 $FILECACHE{$_[0]} = $data;
542 }
543
544 $FILECACHE{$_[0]}
545 }
546
547 sub process_res {
548 while (my $job = $c_res->get) {
549 my ($dir, $file, $type) = @$job;
550
551 my $data;
552 aio_load "$dir/$file", $data;
553
554 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
555
556 utf8::decode $dir;
557 utf8::decode $file;
558
559 # a meta file for resources is now mandatory
560 unless (exists $meta->{$file}) {
561 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
562 next;
563 }
564
565 $meta = {
566 %{ $meta->{"" } || {} },
567 %{ $meta->{$file} || {} },
568 };
569
570 if ($meta->{license} =~ s/^#//) {
571 $meta->{license} = ({
572 "pd" => "Public Domain",
573 "gpl" => "GNU General Public License, version 3.0 or any later",
574 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
575 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
576 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
577 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
578 })->{$meta->{license}}
579 || warn "$dir/$file: license tag '$meta->{license}' not found.";
580 }
581
582 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
583 ($meta->{author} = $1) =~ s/_/ /g;
584 }
585
586 $file =~ s/\.res$//;
587 $file =~ s/\.(ogg|wav|jpg|png)$//;
588
589 substr $dir, 0, 1 + length $PATH, "";
590
591 if (my $filter = $meta->{cfutil_filter}) {
592 if ($filter eq "yaml2json") {
593 $data = JSON::XS::encode_json YAML::XS::Load $data;
594 } elsif ($filter eq "json2json") {
595 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
596 } elsif ($filter eq "perl2json") {
597 $data = eval $data; die if $@;
598 $data = JSON::XS::encode_json $data;
599 } else {
600 warn "$dir/$file: unknown filter $filter, skipping\n";
601 }
602 }
603
604 $RESOURCE{"$dir/$file"} = {
605 type => (exists $meta->{type} ? delete $meta->{type} : $type),
606 data => $data,
607 %$meta ? (meta => $meta) : (),
608 };
203 } 609 }
204 } 610 }
205 611
206 sub find_files; 612 sub find_files;
207 sub find_files { 613 sub find_files {
210 IO::AIO::aioreq_pri 4; 616 IO::AIO::aioreq_pri 4;
211 IO::AIO::aio_scandir $path, 4, sub { 617 IO::AIO::aio_scandir $path, 4, sub {
212 my ($dirs, $nondirs) = @_; 618 my ($dirs, $nondirs) = @_;
213 619
214 find_files "$path/$_" 620 find_files "$path/$_"
215 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 621 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
622
623 my $dir = $path;
624 substr $dir, 0, 1 + length $PATH, "";
216 625
217 for my $file (@$nondirs) { 626 for my $file (@$nondirs) {
627 if ($dir =~ /^music(?:\/|$)/) {
628 $c_res->put ([$path, $file, 3]) # FT_MUSIC
629 if $file =~ /\.(ogg)$/;
630
631 } elsif ($dir =~ /^sound(?:\/|$)/) {
632 $c_res->put ([$path, $file, 5]) # FT_SOUND
633 if $file =~ /\.(wav|ogg)$/;
634
635 } elsif ($dir =~ /^res(?:\/|$)/) {
636 if ($file =~ /\.(jpg|png)$/) {
637 $c_res->put ([$path, $file, 0]) # FT_FACE
638 } elsif ($file =~ /\.(res)$/) {
639 $c_res->put ([$path, $file, 6]) # FT_RSRC
640 } else {
641 $c_res->put ([$path, $file, undef]);
642 }
643
218 if ($file =~ /\.png$/) { 644 } elsif ($file =~ /\.png$/) {
219 push @png, "$path/$file"; 645 push @c_png, ["$path/$file", 0];
646
220 } elsif ($file =~ /\.trs$/) { 647 } elsif ($file =~ /\.trs$/) {
221 push @trs, [$path, $file]; 648 $c_trs->put ([$path, $file]);
649
222 } elsif ($file =~ /\.arc$/) { 650 } elsif ($file =~ /\.arc$/) {
223 push @arc, [$path, $file]; 651 $c_arc->put ([$path, $file]);
652
224 } else { 653 } else {
225 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 654 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
226 } 655 }
227 } 656 }
228 }; 657 };
658 }
659
660 sub generate_plurals {
661# use Lingua::EN::Inflect ();
662# Lingua::EN::Inflect::classical;
663# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
664# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
665#
666# for my $a (@ARC) {
667# my $name = $a->{name} || $a->{_name};
668#
669# next unless $a->{name_pl};
670# next if $a->{invisible};
671# next if $a->{is_floor};
672# next if $a->{no_pick};
673#
674# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
675# my $pl = $test =~ /^(?:eq|p:.)$/
676# ? $name
677# : Lingua::EN::Inflect::PL $name;
678#
679# if ($pl ne $a->{name_pl}) {
680# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
681# }
682# }
229 } 683 }
230 684
231 sub inst_arch($) { 685 sub inst_arch($) {
232 my (undef, $path) = @_; 686 my (undef, $path) = @_;
233 687
688 $PATH = $path;
689
690 print "\n",
234 print "installing '$path' to '$DATADIR'\n\n"; 691 "Installing '$path' to '$DATADIR'\n",
692 "\n",
693 "This can take a long time if you run this\n",
694 "for the first time or do not use --cache.\n",
695 "\n",
696 "Unless you run verbosely, all following warning\n",
697 "or error messages indicate serious problems.\n",
698 "\n";
235 699
236 if (!-d "$path/treasures") { 700 if (!-d "$path/treasures") {
237 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 701 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
238 exit 1 unless $FORCE; 702 exit 1 unless $FORCE;
239 } 703 }
240 704
705 print "scanning files...\n" if $VERBOSE;
706
241 find_files $path; 707 find_files $path;
708
709 my @a_arc = map +(async \&process_arc), 1..2;
710 my @a_res = map +(async \&process_res), 1..2;
711 my @a_trs = map +(async \&process_trs), 1..2;
712
242 IO::AIO::flush; 713 IO::AIO::flush;
243 714
244 $_->join for ( 715 $c_res->shutdown;
245 (async \&process_png), (async \&process_png), 716 $c_arc->shutdown;
246 (async \&process_trs), (async \&process_trs), 717 $c_trs->shutdown;
247 (async \&process_arc), (async \&process_arc), 718
719 print "start file scan, arc, res processing...\n" if $VERBOSE;
720
721 $_->join for @a_arc; # need to parse all archetypes before png processing
722
723 print "end arc, start png processing...\n" if $VERBOSE;
724
725 # eight png crunchers work fine for my 4x smp machine
726 my @a_png = map +(async \&process_png), 1..8;
727
728 $_->join for (@a_trs, @a_res, @a_png);
729
730 print "scanning done, processing results...\n" if $VERBOSE;
248 ); 731 {
732 # remove path prefix from editor_folder
733 $_->{editor_folder} =~ /^\x00/
734 and substr $_->{editor_folder}, 0, 2 + length $path, ""
735 for values %ARC;
249 736
250 die "--install-arch not yet implemented\n"; 737 print "resolving inheritance tree...\n" if $VERBOSE;
738 # resolve inherit
739 while () {
740 my $progress;
741 my $loop;
742
743 for my $o (values %ARC) {
744 for my $other (split /,/, $o->{inherit}) {
745 if (my $s = $ARC{$other}) {
746 if ($s->{inherit}) {
747 $loop = $s;
748 } else {
749 delete $o->{inherit};
750 my %s = %$s;
751 delete @s{qw(_name more name name_pl)};
752 %$o = ( %s, %$o );
753 ++$progress;
754 }
755 } else {
756 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
757 delete $ARC{$o->{_name}};
758 }
759 }
760 }
761
762 unless ($progress) {
763 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
764 if $loop;
765
766 last;
767 }
768 }
769
770 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
771 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
772
773 print "generating plurals...\n" if $VERBOSE;
774 generate_plurals;
775
776 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
777 open my $fh, ">:utf8", "$DATADIR/archetypes~"
778 or die "$DATADIR/archetypes~: $!";
779 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
780 }
781
782 {
783 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
784 open my $fh, ">:utf8", "$DATADIR/treasures~"
785 or die "$DATADIR/treasures~: $!";
786 print $fh $TRS;
787 }
788
789 {
790 print "processing facedata...\n" if $VERBOSE;
791 while (my ($k, $v) = each %FACEINFO) {
792 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
793 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
794
795 make_hash $k, $v->{data32}, $v->{hash32};
796 make_hash $k, $v->{data64}, $v->{hash64};
797
798 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
799 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
800
801 if (my $magicmap = $v->{magicmap}) {
802 $magicmap =~ y/A-Z_\-/a-z/d;
803 $v->{magicmap} = $COLOR{$magicmap};
804 }
805
806 delete $v->{arc};
807 }
808
809 print "processing resources...\n" if $VERBOSE;
810 my $enc = JSON::XS->new->utf8->canonical->relaxed;
811 while (my ($k, $v) = each %RESOURCE) {
812
813 if ($v->{meta} && $v->{meta}{datadir}) {
814 delete $RESOURCE{$k};
815
816 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
817
818 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
819 open my $fh, ">:raw", "$DATADIR/$k~"
820 or die "$DATADIR/$k~: $!";
821 syswrite $fh, $v->{data};
822 push @COMMIT, $k;
823
824 } else {
825 if ($v->{type} & 1) {
826 # prepend meta info
827
828 my $meta = $enc->encode ({
829 name => $k,
830 %{ $v->{meta} || {} },
831 });
832
833 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
834 }
835
836 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
837 }
838 }
839
840 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
841 scalar keys %FACEINFO,
842 scalar keys %ANIMINFO,
843 scalar keys %RESOURCE
844 if $VERBOSE;
845
846 open my $fh, ">:perlio", "$DATADIR/facedata~"
847 or die "$DATADIR/facedata~: $!";
848
849 print $fh nfreeze {
850 version => 2,
851 faceinfo => \%FACEINFO,
852 animinfo => \%ANIMINFO,
853 resource => \%RESOURCE,
854 };
855
856 }
857
858 print "committing files...\n" if $VERBOSE;
859
860 for (qw(archetypes facedata treasures), @COMMIT) {
861 chmod 0644, "$DATADIR/$_~";
862 rename "$DATADIR/$_~", "$DATADIR/$_"
863 or die "$DATADIR/$_: $!";
864 }
865
866 print "archetype data installed successfully.\n";
251 } 867 }
252} 868}
253 869
254Getopt::Long::Configure ("bundling", "no_ignore_case"); 870Getopt::Long::Configure ("bundling", "no_ignore_case");
255GetOptions ( 871GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines